/*
 * Initial Developer's Public License.
 * The contents of this file are subject to the  Initial Developer's Public
 * License Version 1.0 (the "License"). You may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *   http://www.ibphoenix.com?a=ibphoenix&page=ibp_idpl
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is copyright 2004-2005 Paul Reeves.
 *
 * The Initial Developer of the Original Code is Paul Reeves
 *
 * All Rights Reserved.
 *
 */

-- This example uses a trigger to generate an EXECUTE STATEMENT
-- based on the contents of the inserted record.
-- Note that this technique is particularly unsuitable for a live
-- multi-user environment. However, it is fine if there is
-- exclusive access to the database and each insert is committed.

create table revisions(
 revisions_code integer not null,
 sql_text varchar(2048) not null,
 exec_time timestamp default 'now',
 exec_by varchar(31) default CURRENT_USER,
 constraint pk_revisions primary key (revisions_code)
 );


-- Create a trigger to do the work for us.
create generator REVISIONS_GEN;
set term ^;
create trigger tib_revisions for revisions
active before insert position 0 as
DECLARE VARIABLE Sql VARCHAR(2048);

begin
/* Generate id on Primary key*/
if (New.REVISIONS_CODE is null) then
  New.REVISIONS_CODE=Gen_Id(REVISIONS_GEN,1);

sql = new.sql_text;
execute statement sql;

end^
set term ;^

commit;


