::  Initial Developer's Public License.
::  The contents of this file are subject to the  Initial Developer's Public
::  License Version 1.0 (the "License"). You may not use this file except
::  in compliance with the License. You may obtain a copy of the License at
::    http://www.ibphoenix.com?a=ibphoenix&page=ibp_idpl
::  Software distributed under the License is distributed on an "AS IS" basis,
::  WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
::  for the specific language governing rights and limitations under the
::  License.
::
::  The Original Code is copyright 2004-2005 Paul Reeves.
::
::  The Initial Developer of the Original Code is Paul Reeves
::
::  All Rights Reserved.
::
::=============================================================================


@echo off

::Check if on-line help is required
for %%v in ( %* )  do (
  ( @if /I "%%v"=="-h" (goto :HELP & goto :EOF) )
  ( @if /I "%%v"=="/h" (goto :HELP & goto :EOF) )
  ( @if /I "%%v"=="HELP" (goto :HELP & goto :EOF) )
)


@goto :MAIN
@goto :EOF


:HELP
::===
@echo.
@echo.
@echo     Run this script from a console prompt.
@echo     Pass the name of the master script as the one and only parameter.
@echo     This master script must have the same name as the alias used
@echo     for the database that is being worked on.
@echo.
@echo     If the alias does not exist in alias.conf it will be added.
@echo     This step requires that you have the env. var FB_DATA defined
@echo     and the alias will be set to:
@echo.
@echo       %%ALIAS%% = %%FB_DATA%%\%%ALIAS%%.fdb
@echo.
@echo     Other available parameters:
@echo.
@echo       HELP       This help screen.
@echo.
@echo.
@goto :EOF


:ERROR
::====
@echo.
@echo   Error in execsql.bat
@echo     %*
@echo.
popd
:: Attempt to execute a phony command. This will ensure
:: that ERRORLEVEL is set on exit.
cancel_script > nul 2>&1
::End of ERROR
::------------
endlocal
@goto :EOF


::============
:MAIN

:: Check we have a param on the command line
@if "%1"=="" (goto :HELP & goto :EOF) else (
set ALIAS=%1
)

@echo off

::Delete old log
del /q %1.txt > nul 2>&1

::Check we have an alias for %1
:: If it doesn't exist then check for FB_DATA and
:: try and create it.
@findstr /b /i %ALIAS% %FIREBIRD%\aliases.conf > nul
@if %ERRORLEVEL% GEQ 1 (
@if "%FB_DATA%"=="" (
  call :ERROR Could not locate an alias for this database  & goto :EOF
) else (
  @echo %ALIAS% = %FB_DATA%\%ALIAS%.fdb >> %FIREBIRD%\aliases.conf
  @echo. >> %FIREBIRD%\aliases.conf
  @echo added %ALIAS% alias
))

::run creation script
if EXIST %ALIAS%.sql (
@echo Running %ALIAS%.sql...
isql.exe -e -i %ALIAS%.sql -o %ALIAS%.txt -m -m2 > nul
) else (
 @echo Could not find %ALIAS%.sql.
 @echo Exiting.
 goto :EOF
)

::print errors
@echo Checking for Errors
@findstr /n /i /c:"statement failed" /c:"unable" %ALIAS%.txt || (
@echo No errors found.
@echo Script completed successfully.
)

::endlocal
goto :EOF

