/*
 * Initial Developer's Public License.
 * The contents of this file are subject to the  Initial Developer's Public
 * License Version 1.0 (the "License"). You may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *   http://www.ibphoenix.com?a=ibphoenix&page=ibp_idpl
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is copyright 2004-2005 Paul Reeves.
 *
 * The Initial Developer of the Original Code is Paul Reeves
 *
 * All Rights Reserved.
 *
 */


-- This is script generates grants to public etc automatically
-- See more extensive comments in alter_all.ddl for more info.


set list on;
set echo off;
shell del autogrant.ddl;
shell del grants_isql.txt;
output autogrant.ddl;

select 'GRANT ALL ON ' || RDB$RELATION_NAME || ' to public;'
from RDB$RELATIONS
where RDB$RELATION_NAME not starting with 'RDB$';

select distinct 'GRANT ALL ON ' || RDB$VIEW_NAME || ' to public;'
from RDB$VIEW_RELATIONS
where RDB$VIEW_NAME not starting with 'RDB$';

select distinct 'GRANT EXECUTE ON PROCEDURE ' || RDB$PROCEDURE_NAME || ' to public;'
from RDB$PROCEDURES
where RDB$PROCEDURE_NAME not starting with 'RDB$';

output grants_isql.txt;
set echo on;
input autogrant.ddl;
commit;




